<?php

// ===================================================================================
// modification des puces
// ===================================================================================
$GLOBALS['puce'] = '<li class="spip">';

// ===================================================================================
//  pour plugin squelette TdT2
// ===================================================================================

// ===============================
// Balise : #VERSION_SPIP_AFFICHEE
// ===============================
// Balise pour afficher la version de SPIP en cours sur votre site
// Contrib de Scoty : http://www.koakidi.com/
// voir : http://www.spip-contrib.net/Collection-de-Balises
function balise_VERSION_SPIP_AFFICHEE($p) {
        $p->code = "'".$GLOBALS['spip_version_affichee']."'";
        $p->statut = 'php';
        return $p;
}

// ==============================
// Balise : #VERSION_SQUELETTE
// ==============================
// Auteur: SarkASmeL
// Fonction : affiche la version utilise du squelette variable globale $version_squelette
// ==============================
function balise_VERSION_SQUELETTE($p) {
	$p->code = 'calcul_version_squelette()';
	$p->interdire_scripts = false;
	return $p;
}

function calcul_version_squelette() {

	$version = NULL;
	
	if (lire_fichier(_DIR_PLUGIN_TdT2.'/plugin.xml', $contenu)
	&& preg_match('/<version>(.*?)<\/version>/', $contenu, $match))
		$version .= trim($match[1]);

	$revision = version_svn_courante(_DIR_PLUGIN_TdT2);
	if ($revision > 0)
		$version .= ' ['.strval($revision).']';
	else if ($revision < 0)
		$version .= ' ['.strval(abs($revision)).'&nbsp;<strong>svn</strong>]';

	return $version;
}

// ===================================================================================
// ===================================================================================

/*
 * Nom du filtre      : QCM
 * Auteur             : Mathieu GIANNECCHINI
 * Date               : 7 Ao?t 2003
 * http://www.spip-contrib.net/Filtre-QCM
 * Fonction du filtre : Parse le code du QCM tap? dans SPIP et stocke
 *                      les questions, r?ponses et commentaires
 *                      dans un tableau et retourne le code HTML du QCM
 */
function qcm($chaine){

  /* Messages utilis?s dans le QCM
   */
  //$titreQCM="QCM";
  $reponseJuste="La réponse est juste";
  $reponseFausse="La réponse est fausse";
  $reponseNulle="Vous n'avez pas répondu";
  
  /* Bascule permettant de gérer les points spécifiés dans le 
   * code du QCM
   */
  $gestionPoint=true;

  /* Booléen permettant de savoir si il y a un QCM dans l'article
   */
  $qcm=false;
 
  /* Initialisation du score
   */
  $score=0;

  /* On récupére le code du qcm entre <qcm> et </qcm>
   */
  while(ereg("<qcm>",$chaine)){
  $qcm=true;
  $codeHTML="";
  list($texteAvant,$suite)=explode("<qcm>",$chaine,2); 
  list($qcm,$texteApres)=explode("</qcm>",$suite,2); 
 
  /* On isole les questions les réponses et les commentaires
   */
  $ligne=split("\n",$qcm);
  $nbligne=count($ligne);

  $premierequestion=$nbQuestion;
     
  for($i=0;$i<$nbligne;$i++){
    /* Pour chaque ligne on regarde le premier caractére
     */
    switch($ligne[$i][0]){
      case 'T' : $titreQCM=substr($ligne[$i],1);break;
      case 'Q' : 
	$nbQuestion++;
	$question[$nbQuestion]=substr($ligne[$i],1);
        break;

      case 'P' : 
	/* On extrait les précisions de la proposition
  	 */	
 	list($reponse,$precis)=explode("|",$ligne[$i]);
	
	/* On extrait le numéro de la proposition et son contenu
  	 */
	ereg("P([0-9]+)(.*)",$reponse,$eregResult1);	
	$numPropos=$eregResult1[1];

        /* On extrait les points éventuellement associés
         *  à chaque réponse
         */
        if(ereg("[.](-?[0-9]+)(.*)",$eregResult1[2],$eregResult2)){
          $points[$nbQuestion][$numPropos]=$eregResult2[1];
          $choix[$nbQuestion][$numPropos]= $eregResult2[2];
          //$gestionPoint=true;
        }
        /* Si une erreur de syntaxe apparait
         * on passe en mode par défaut pour la gestion des points
         */
	else{
          $gestionPoint=false;
          $choix[$nbQuestion][$numPropos]= $eregResult1[2];
        }        
       	$precision[$nbQuestion][$numPropos]= $precis;
	break;
	
      case 'R' :
	/* On récupére le numéro de la bonne réponse
 	 */ 
	ereg("R([0-9]+)(.*)",$ligne[$i],$eregResult);	
	$numProposition=$eregResult[1];
	$bonneReponse[$nbQuestion]=$numProposition;
	break;

      default  : break;
    }
  }	

  /* 
   * Affichage du QCM
   */ 
  // Si on ne corrige pas on affiche le QCM
  if (!isset($GLOBALS["var_correction"])){
    for($i=$premierequestion+1;$i<=count($question);$i++){
     $nomVarSelect="var_Q".$i;
     $codeHTML.="<div class=\"spip_qcm_question\"><IMG SRC=\"puce.gif\"> $question[$i]</div>";
     $codeHTML.="<div class=\"spip_qcm_proposition\">";

      // Si il ya plus de 5 choix, on utilise une liste
      if(count($choix[$i])>5){
        $codeHTML.="<select name=\"$nomVarSelect\" class=\"spip_qcm_select\">";
	for($j=1;$j<=count($choix[$i]);$j++){
          $codeHTML.="<option value=\"$j\">";
	  $codeHTML.=$choix[$i][$j]."</option>";
        }
	$codeHTML.="</select>";
      }
      // Sinon des radio boutons
      else{
        for($j=1;$j<=count($choix[$i]);$j++){
          $codeHTML.="
	   <input 
              type=\"radio\" 
              name=\"$nomVarSelect\"
              value=\"$j\">";
	  $codeHTML.=$choix[$i][$j]."<br />";
         }
       }
       $codeHTML.="</div><br />";
       
     }// Fin traitement des questions
    }//Fin du cas sans correction

    // Sinon on affiche la correction
    else{
     
      // Initialisation du code  à retourner
      $codeHTML="";
 
      for($i=$premierequestion+1;$i<=count($question);$i++){
        $nomVarSelect="var_Q".$i;
        
        /* On comptabilise le maximum de points que l'on peut obtenir
         */
        if($gestionPoint){
          $pointParQuestion=$points[$i][$bonneReponse[$i]];
          $scoreMax+=$pointParQuestion;
        }
        else{
          $pointParQuestion=1;
          $scoreMax+=$pointParQuestion;
        }
       
        // La réponse choisie
        $codeHTML.="<div class=\"spip_qcm_question\"><img src=\"puce.gif\">$question[$i]<span class=\"spip_qcm_point\">($pointParQuestion pt)</span></div>";

        // Si c'est juste
        if($bonneReponse[$i]==$GLOBALS[$nomVarSelect]){
           // Les points par défaut : 1 par bonne r?ponse
           if($gestionPoint){
             $score+=$points[$i][$GLOBALS[$nomVarSelect]];
           }
           else{
             $score++;
           }
           $codeHTML.="<div class=\"spip_qcm_reponse\">$introReponse";
           $codeHTML.=$choix[$i][$GLOBALS[$nomVarSelect]];
           $codeHTML.="</div>";
           $codeHTML.="<div class=\"spip_qcm_correction_juste\">$reponseJuste</div>";
           if (isset($precision[$i][$GLOBALS[$nomVarSelect]])){
             $codeHTML.="<center><div class=\"spip_qcm_precision\">";
       	     $codeHTML.=$precision[$i][$GLOBALS[$nomVarSelect]];
	     $codeHTML.="</div></center>";
           }
        }
        // Si c'est faux
        else{
          if(isset($GLOBALS[$nomVarSelect])){
           $score+=$points[$i][$GLOBALS[$nomVarSelect]];
           $codeHTML.="<div class=\"spip_qcm_reponse\">";
           $codeHTML.=$choix[$i][$GLOBALS[$nomVarSelect]];
           $codeHTML.="</div>";
           $codeHTML.="<div class=\"spip_qcm_correction_faux\">$reponseFausse</div>";
           
           if (isset($precision[$i][$GLOBALS[$nomVarSelect]])){
             $codeHTML.="<center><div class=\"spip_qcm_precision\">";
	     $codeHTML.=$precision[$i][$GLOBALS[$nomVarSelect]];
       	     $codeHTML.="</div></center>";
           }
          }
	  else{
            $codeHTML.="<div class=\"spip_qcm_correction_null\">$reponseNulle</div>";
          } 
        }
        $codeHTML.="<br />";
      }
     
   }
   // On ajoute les balises <HTML> et </HTML>
   $codeHTML="<html>".$codeHTML."</html>";
   
   $chaine=$texteAvant.$codeHTML.$texteApres;
  }//fin du while
  if($qcm){
    if (!isset($GLOBALS["var_correction"])){
       $teteFormulaire="<form method=\"post\" action=\"\">";  
       $piedFormulaire="
       <br>
       <input type=\"hidden\" name=\"var_correction\" value=\"yes\">
       <center><input type=\"submit\" value=\"Corriger\" class=\"spip_qcm_bouton_corriger\"></center>
       </form>";
       $chaine=$teteFormulaire.$chaine.$piedFormulaire;
    }
    else{
      // On ajoute le score final
      $chaine.="<center><div class=\"spip_qcm_score\">Score : $score / $scoreMax<br></div></center>";
      $chaine.="<div class=\"spip_qcm_bouton_corriger\" align=\"right\">[ <a href=\"$PHP_SELF\">R&eacute;initialiser le QCM</a> ]</div>";
      unset($GLOBALS["var_correction"]);
    }

    // $chaine="<center><div class=\"spip_qcm\"><div class=\"spip_qcm_titre\">".$titreQCM."<hr /></div>".$chaine."</div></center>";
  }
   return $chaine;
}
/*
 
?>

